--	implements a simple class builder.


local major, minor, libTable = LibStub("LibBuilder-1.0"):GetLib()
if not libTable.canLoad then return end


libTable.classes = {}


function NewClass(self, name, noInstance)
	assert(name)
	assert(self[name] == nil)
	
	local class = {}
	self[name] = class
	
	if noInstance then
		return class
	else
		local prototype, metatable = {}, {}
		
		class.prototype = prototype
		
		metatable.__index = prototype
		class.instanceMetatable = metatable
		
		return class, prototype
	end
end


libTable.classes.NewClass = NewClass
